#ifndef BALL_H

#include "model.h"

typedef struct ball
{
	NODE*pNode;
	int index;
}BALL;

typedef void HITCHECK(const BALL*b, const MODEL*m);

BALL* NewBall(VECTOR3*Pos, VECTOR3*Vel, v3unit_t r, v3unit_t w, int index);
void DeleteBall(BALL*b);
void BallDraw(const BALL*b);
#endif
