#ifndef DEBUG_H
#define DEBUG_H

//#define _DEBUG

#include <stdio.h>

#ifdef _DEBUG

#define Debug(...) {fprintf(stderr, " at %s:%d %s\n"\
	,__FILE__, __LINE__,__func__,\
	fprintf(stderr, __VA_ARGS__));}
	
#define Assert(check,...) {if(!(check))Debug("Assert:"__VA_ARGS__);}

#else

#define Debug(...)
#define Assert(...)

#endif

#endif
