#ifndef LINK_H
#define LINK_H
/** @file NodeNodeȂLink̐錾
 	
	@auther Naoki_I
 */

#include "node.h"

#define FOR_EACH_LINK_DO(begin, cnt, func) {\
	for(int each=0; each<cnt; each++){(*begin[each]->func)(begin[each]->pData);}}

typedef void LINK_DO_FUNC(void*);
typedef void LINK_DOFINAL_FUNC(void*);
typedef NODE* LINK_GET_NODE_FUNC(void*,int);
typedef int LINK_ENABLE(void*);
int ReturnTrue(void*p);
void DoNothing(void*p);

typedef struct link
{
	LINK_DO_FUNC*pDoFunc;
	LINK_DOFINAL_FUNC*pDoFinalFunc;
	LINK_GET_NODE_FUNC*pGetNode;
	LINK_ENABLE*pEnableFunc;
	
	void*pData;
}LINK;

typedef struct string
{
	NODE *apNode[2];
	v3unit_t Hard;
	v3unit_t NormalLength;
	int Break;
}STRING;


LINK* StringNew(NODE*n0, NODE*n1, v3unit_t hard);
void StringDo(void*pData);
NODE* StringGetNode(void*pData,int i);
int StringEnable(void*pData);
void StringDoFinal(void*pData);
void SetBreakable(int Stat);

typedef struct hook
{
	NODE *pNode;
	VECTOR3 HookPos;
	
}HOOK;

LINK* HookNew(NODE*n, VECTOR3*v);
void HookDo(void*pData);
NODE* HookGetNode(void*pData,int i);


#endif
