/** @file zXN
	
	ERpC@
	@EBhEYGLUTgĂvOƂ
	RpCΒʂ͂łD
	(cygwin̏ꍇ)
	gcc *.c -O3 -std=c99 -lglut32 -lglu32 -lopengl32 -o cloth

	CCWJ҂ďĂ镔R̂
	œKIvVtȂƏdĎgɂȂ܂D
	܂CC99ŏĂ镔ꕔ̂ -std=c99IvVtĂD

	makefilepӂĂ̂ŁCmakeƂĂĂvłD
    
	Emain.c	
	@̃t@Cł̓XN[Z[oƕ\̋@\ɂĒ`Ă܂D
	z̋ɂĂ͂̃t@CȊO݂悢Ǝv܂D
	S̓IɃRg͏Ȃ߂ł...
	XN[Z[oȊO̕
	ɂȂNXV~[^̃\[XQlɂƗǂ܂D
	http://www.flightless-wing.com/
	zV~̃y[WĂD(KȃvOł^^;)
	
	@date 2006-03-03
	@auther Naoki_I
 */

#include <GL/gl.h>
#include <GL/glut.h>

#include <stdlib.h>
#include <stdio.h>
#include <memory.h>
#include <time.h>

#if 1//def WIN32
	#define WIN32_LEAN_AND_MEAN
	#include <windows.h>
	#include <process.h>
	#define THREAD_FUNCTION void
	#define THREAD_RETURN return
#else
	#include <unistd.h>
	#include <pthread.h>
	#define _beginthread(func,xx,prm) {pthread_t thread_id1;pthread_create(&thread_id1,NULL,func,(void *)prm);}
	#define THREAD_FUNCTION void*
	#define THREAD_RETURN return NULL
	#define Sleep(x) usleep((x)*1000)
	#define GetTickCount clock
#endif

#include "debug.h"
#include "model.h"
#include "ball.h"
#include "flag.h"
#include "skirt.h"

//萔
#define IDM_SKIRT			0x006
#define IDM_FLAG_VERTICAL	0x002
#define IDM_FLAG_HORIZONTAL	0x004
#define IDM_FLAG_LOCK		0x001

#define IDM_WIND_NO		0x0
#define IDM_WIND_LOW	0x5
#define IDM_WIND_HIGH	0x10

#define IDM_BREAK_DISABLE 0x0
#define IDM_BREAK_ENABLE 0x1

#define IDM_EXIT 42

const v3unit_t BALLR=0.25f;
const v3unit_t BALLW=50.0f;

#define CLOTH_NUM 7
MODEL*g_apCloth[CLOTH_NUM]={0,0,0,0,0,0,0};	//0:ANeBuȊ 1:unuse 2~4:IDM_FLAG_* ɑΉ 
#define MAX_BALL 32
BALL*g_apBall[MAX_BALL+1];
NODE**g_apNode=0;
int g_NodeCnt;

//XN[Z[o̐ݒ
typedef struct seen
{
	int cloth;
	int wind;
	int ball;	//0: 1:Ƃ 2:
	int poly;	//GL_FILL GL_WIRE
	struct seen*next; //O
}SEEN;
SEEN *g_pNowSeen=NULL;
long g_TimerSec;
int g_BallShoot;

extern VECTOR3 WindForce;

int g_Width, g_Height;

//SẴm[hi[ׂg_apNodez
//ݏ̃m[hi[
void SetNodeArray(MODEL*pFlag)
{
	int i, Cnt=MAX_BALL+pFlag->NodeCnt +1;

	if(g_apNode)free(g_apNode);
	g_apNode=(NODE**)malloc(sizeof(NODE*)*Cnt);
	
	
	for(i=0; i<pFlag->NodeCnt; i++)
	{
		g_apNode[i]=pFlag->apNode[i];
	}
	for(i=0;i<MAX_BALL; i++)
	{
		g_apNode[pFlag->NodeCnt+i]=g_apBall[i]?g_apBall[i]->pNode:NULL;
	}
	g_NodeCnt=Cnt-1;
	g_apNode[g_NodeCnt]=NULL;
}

void ExitMe(int param)
{
	ShowCursor(TRUE);
	exit(param);
}

//ʑŜ`
void display(void)
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	
	glLoadIdentity();
	
	//ɉĂ
	glTranslatef(-1.5f, -0.5f, -6.0f);		 
	
	glBegin(GL_QUADS);
	
	glPushMatrix();
	
	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, (float[]){0.3f, 0.3f, 0.3f, 1.0f});
	glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, (float[]){0.5f, 0.5f, 0.5f, 1.0f});
	glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, (float[]){0.0f,0.0f,0.0f,0.0f});
	glMaterialfv(GL_FRONT_AND_BACK, GL_SHININESS, (float[]){0.0f});
	
	ModelDraw(g_apCloth[0]);
	glPopMatrix();
    
	glEnd();
	for(int i=0; g_apBall[i]; i++)
	{
		glPushMatrix();	
		BallDraw(g_apBall[i]);
		glPopMatrix();	
	}
	glutSwapBuffers();
}

void reshape(int w, int h)
{
	glutFullScreen();
	
	g_Width=w;
	g_Height=h;
	glViewport(0, 0, (GLsizei)w, (GLsizei)h);
	glMatrixMode(GL_PROJECTION);	
	glLoadIdentity();
	gluPerspective(45.0f, (GLfloat)w/(GLfloat)h, 0.01f, 50.0f);
	//glOrtho(-2.0, 2.0, -2.0, 2.0, 0.001, 50.0);
	
	glMatrixMode (GL_MODELVIEW);
}

//j[NbNꂽ
void MainMenu(int entry)
{
	switch(entry)
	{
		case IDM_EXIT:
			ExitMe(1);
	}
}

void PolygonMode(int mode)
{
	glPolygonMode(GL_FRONT_AND_BACK, mode);
}
void ChangeCloth(int flag)
{
	g_apCloth[0]=g_apCloth[flag];
	SetNodeArray(g_apCloth[0]);
}
void Wind(int wind)
{
	WindForce.v[0]=wind/1024.0;
}

void SetSeen(SEEN*pSeen)
{
	ChangeCloth(pSeen->cloth);
	Wind(pSeen->wind);
	PolygonMode(pSeen->poly);
	g_BallShoot=pSeen->ball;
}

void CheckTimer()
{
	static long BeforeTime=0;
	if(!BeforeTime)
		BeforeTime=GetTickCount();
	
	long Now=GetTickCount();
	long Dist=Now-BeforeTime;
	
	if(Dist>g_TimerSec*1000)
	{
		g_pNowSeen=g_pNowSeen->next;
		SetSeen(g_pNowSeen);
		BeforeTime=Now;
	}
}

///j[
void InitMenu()
{
	int MenuPolygonMode,
		MenuFlag, MenuFlagV, MenuFlagH,
		MenuWind
		,MenuBreak;
	
	MenuPolygonMode = glutCreateMenu(PolygonMode);
	glutAddMenuEntry("Fill", GL_FILL);
	glutAddMenuEntry("Line", GL_LINE);
	
	MenuFlagV = glutCreateMenu(ChangeCloth);
	glutAddMenuEntry("Locked", IDM_FLAG_VERTICAL|IDM_FLAG_LOCK);
	glutAddMenuEntry("Unlocked", IDM_FLAG_VERTICAL);
	
	MenuFlagH = glutCreateMenu(ChangeCloth);
	glutAddMenuEntry("Locked", IDM_FLAG_HORIZONTAL|IDM_FLAG_LOCK);
	glutAddMenuEntry("Unlocked", IDM_FLAG_HORIZONTAL);
	
	MenuFlag=glutCreateMenu(ChangeCloth);
	glutAddSubMenu("VerticalFlag", MenuFlagV);
	glutAddSubMenu("HorizontalFlag", MenuFlagH);
	glutAddMenuEntry("Skirt", IDM_SKIRT);
	
	MenuWind=glutCreateMenu(Wind);
	glutAddMenuEntry("Nothing", IDM_WIND_NO);
	glutAddMenuEntry("Low", IDM_WIND_LOW);
    glutAddMenuEntry("High", IDM_WIND_HIGH);
	
	MenuBreak=glutCreateMenu(SetBreakable);
	glutAddMenuEntry("Enable", IDM_BREAK_ENABLE);
	glutAddMenuEntry("Disable", IDM_BREAK_DISABLE);

	glutCreateMenu(MainMenu);
	glutAddSubMenu("PolygonMode", MenuPolygonMode);
	glutAddSubMenu("Cloth", MenuFlag);
	glutAddSubMenu("Wind", MenuWind);
	glutAddSubMenu("Break", MenuBreak);
	
	glutAddMenuEntry("Quit", IDM_EXIT);
	glutAttachMenu(GLUT_RIGHT_BUTTON);
}

void InitCloth()
{
	const int SW=18, SH=18;
	const v3unit_t Width=3.0, Height=2.0;
	  
	g_apCloth[IDM_FLAG_VERTICAL]
		=NewFlag(0, 0, 0.5f, Width, Height, SW, SH);
		
	g_apCloth[IDM_FLAG_VERTICAL|IDM_FLAG_LOCK]
		=NewFlag(0, 1, 0.5f, Width, Height, SW, SH);
	
	g_apCloth[IDM_FLAG_HORIZONTAL]
		=NewFlag(1, 0, 0.75f, Width, Height*1.5, SW, SH);
	
	g_apCloth[IDM_FLAG_HORIZONTAL|IDM_FLAG_LOCK]
		=NewFlag(1, 1, 0.75f, Width, Height*1.5, SW, SH);
	
	g_apCloth[IDM_SKIRT]
		=NewSkirt(0.5f, 2.0, 2.0, 68, 8);
}

void init()
{
	const float Pos[]={30.0f, 30.0f, 30.0f, 1.0f};

	glLightfv(GL_LIGHT0 , GL_POSITION , Pos);
	glLightfv(GL_LIGHT0 , GL_DIFFUSE , (float[]){1.0f, 1.0f, 1.0f, 1.0f});
	glLightfv(GL_LIGHT0, GL_SPECULAR, (float[]){1.0f, 1.0f, 1.0f, 1.0f});
	glLightfv(GL_LIGHT0, GL_AMBIENT, (float[]){1.0f, 1.0f, 1.0f, 1.0f});

    glEnable(GL_DEPTH_TEST);
    glEnable(GL_LIGHTING);
    glEnable(GL_LIGHT0);

	glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
	glClearColor(0.0f, 0.0f, 0.1f, 0.0f);
	glShadeModel(GL_SMOOTH);
	
	ShowCursor(FALSE);
}

//~Ƀ\[g
int BallComp(const void *a, const void *b)
{
	BALL*b0=(BALL*)*(BALL**)a;
	BALL*b1=(BALL*)*(BALL**)b;
	if(!b1)
		return -1;
	if(!b0)
		return 1;

	if(b0->pNode->LPos.v[1]-b0->pNode->r > b1->pNode->LPos.v[1]-b1->pNode->r)
		return -1;
	else
		return 1;
}

BALL*AddBall(VECTOR3*pPos, VECTOR3*pVel)
{
	static unsigned int BallI=0;
	if(g_apBall[MAX_BALL-1])
	{
		DeleteBall(g_apBall[MAX_BALL-1]);
		g_apBall[MAX_BALL-1]=NULL;
	}
	BALL*ret=g_apBall[MAX_BALL-1]
		=NewBall(
			pPos,
			pVel,
			BALLR, BALLW, 
			BallI);
	BallI++;
	if(BallI>=MAX_BALL)
		BallI=0;
	qsort(g_apBall, MAX_BALL, sizeof(BALL*), BallComp);
	SetNodeArray(g_apCloth[0]);
	return ret;
}

void MaybeAddBall()
{
	if(g_BallShoot==0)
		return;
	
	if(g_BallShoot==1)
	{
		static int i=0;
		
		if(i++>8)
		{	
			AddBall(&(VECTOR3){1.0+(rand()%100)/50.0, 2.0+(rand()%100)/30.0, 0.0},
				&(VECTOR3){0.0, 0.0, 0.0});
			i=0;
		}
	}
	else
	{
		static int i=0;
		static int b=0;
		static BALL*pBall;
		if(i++<8)
			return;
		
		if(!b)
		{
			pBall=AddBall(&(VECTOR3){1.5, 0, 2.0},
				&(VECTOR3){10.0, 0.0, 50.0});
		}
		else
		{
           	v3PlusEq(&pBall->pNode->Pos, &(VECTOR3){{
				0.05-(rand()%100)/1000.0,
				0.25-(rand()%100)/500.0,
				-0.1f-(rand()%100)/500.0
				}});
			i=0;
		}
		b^=1;
	}
}

void motion(int x, int y)
{
	static int bx=-1, by=-1;
	if( bx>0 &&(abs(bx-x)>5 || abs(by-y)>5))
		ExitMe(0);
	bx=x; by=y;
}

void mouse(int button, int state, int x, int y)
{
	ExitMe(0);
	/*
	static BALL*pBall=0;
	static int PreX, PreY;
    if(button==GLUT_LEFT_BUTTON && state==GLUT_DOWN)
	{
		PreX=x;
		PreY=y;
    	pBall=AddBall(&(VECTOR3){1.5, 0, 3.0},
			&(VECTOR3){0.0, 0.0, -1.0});
	}
	else if(button==GLUT_LEFT_BUTTON && state==GLUT_UP)
	{
		if(pBall)
		{
			v3PlusEq(&pBall->pNode->Pos, &(VECTOR3){{
				0.2f*(x-PreX)/g_Width,
				0.3f*(v3unit_t)(PreY-y)/g_Height,
				-0.1f-0.2f*(PreY-y)/g_Height}});
		}
    }
	*/
}

void keyboard(unsigned char key, int x, int y)
{
	ExitMe(1);
	/*
	static int BallIndex=0;
	switch(key)
	{
	case ' ':
		AddBall(&(VECTOR3){1.0+BallIndex/10.0, 2.0, 0.0},
			&(VECTOR3){0.0, 0.0, -1.0});
		BallIndex=++BallIndex%16;
		break;
	default :
		ExitMe(1);
	}
	glutPostRedisplay();
	*/
}

void KeepFPS(int MaxFPS)
{
	static long BeforTime=0;
	long Now=GetTickCount();
	long Keika=Now-BeforTime;
	int Dist=1000/MaxFPS-Keika;
	if(Dist>0)
		Sleep(Dist);
	BeforTime=GetTickCount();
}

/*
	m[hɃ\[g
 */
int NodeComp(const void *a, const void *b)
{
	NODE*n0=(NODE*)*(NODE**)a;
	NODE*n1=(NODE*)*(NODE**)b;
	if(!n1)
		return -1;
	if(!n0)
		return 1;

	if(n0->LPos.v[0]-n0->r > n1->LPos.v[0]-n1->r)
		return 1;
	else
		return -1;
}

THREAD_FUNCTION loop(void*pData)
{
	int i;
	//ʂ̔˂randgĂ
	srand((unsigned int)time(0));
	
	while(1)
	{
		//@vZ
		ModelCalcNV(g_apCloth[0]);
	
		//m[hړ
		NodesMove(g_apNode);
		
		//͂
		ModelForce(g_apCloth[0]);
		NodesForce(g_apNode);
		
		//m[hԂ̋̐
		//JԂČʂ
		int ani=32;
		qsort(g_apNode, g_NodeCnt, sizeof(NODE*), NodeComp);
		for(int i=0; i<ani; i++)
		{
			NodesAdjust(g_apNode);
			ModelAdjust(g_apCloth[0]);
		}
		ModelFinal(g_apCloth[0]);
		CheckTimer();
		MaybeAddBall();		
		glutPostRedisplay();
		KeepFPS(30);
	}
	THREAD_RETURN;
}

SEEN* NewSeen(char*pBuf)
{
	if(pBuf[0]=='#' || strspn(pBuf, "tyschlouw")==0)
		return NULL; //Rg͋̍s
	
	SEEN*pNew;
	char*pWord;
	int lock=0;
	
	//ftHg
	pNew=(SEEN*)malloc(sizeof(SEEN));
	pNew->cloth=IDM_FLAG_VERTICAL;
	pNew->wind=IDM_WIND_NO;
	pNew->ball=0;
	pNew->poly=GL_FILL;
	pNew->next=pNew;
	
	do
	{
		//puts(pBuf);
		switch(pBuf[0])
		{				
			case 't':	//tate
				pNew->cloth=IDM_FLAG_VERTICAL;
				break;
			case 'y':	//yoko
				pNew->cloth=IDM_FLAG_HORIZONTAL;
			    break;
			case 's':
				pNew->cloth=IDM_SKIRT;
			    break;	
				
			case 'c':	//cloth-lock
				lock=1;
				break;
				
			case 'h':	//high-wind
				pNew->wind=IDM_WIND_HIGH;
				break;
			case 'l':	//low-wind
				pNew->wind=IDM_WIND_LOW;
				break;
			
			case 'o':	//otosu-ball
				pNew->ball=1;
				break;
			case 'u':	//utu-ball
				pNew->ball=2;
				break;
			
			/*case 'w':	//wire
				pNew->poly=GL_LINE;
				break;*/
		}
		if(!(pWord=strchr(pBuf, ' ')))
			break;
		pBuf=pWord+1;
	}while(1);
	
	if(pNew->cloth!=IDM_SKIRT && lock)
		pNew->cloth|=IDM_FLAG_LOCK;
	return pNew;
}

void LoadSetting(FILE*fp)
{
	const int BUF_SIZE=0xFF;
	char Buf[BUF_SIZE];
	char *pWord;
	SEEN*pNow,*pNew;
	pNow=NULL;
	while(fgets(Buf, BUF_SIZE, fp))
	{
		if(Buf[0]=='i')
		{
			//V[؂ւ̊Ԋu
			int sec=0;
			sscanf(Buf, "interval %d", &sec);
			if(sec>0)
				g_TimerSec=sec;
			continue;
		}
		if(!(pNew=NewSeen(Buf)))
			continue;
		if(pNow)
		{
			pNow->next=pNew;
		}
		
		pNow=pNew;
			
		if(!g_pNowSeen)
		{
			g_pNowSeen=pNew;
		}
	}
	if(!g_pNowSeen)
		pNow=g_pNowSeen=NewSeen("t h");
	
	pNow->next=g_pNowSeen;
}

int main(int argc, char** argv)
{
	FILE*f=fopen("c:\\scr.txt", "w");
	
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
	glutCreateWindow("cloth_scr");
	glutDisplayFunc(display);
	glutReshapeFunc(reshape);
	glutKeyboardFunc(keyboard);
	glutMouseFunc(mouse);	//}EXNbN
	glutPassiveMotionFunc(motion);	//}EX𓮂
	
	init();
	//InitMenu();
	InitCloth();
	
	//ݒǂݍ
	g_TimerSec=5;
	
	//t@C
	char FileName[MAX_PATH], *pYen;
	pYen=strrchr(argv[0], '\\');
	if(pYen)
		*(pYen+1)=0;
	else
		argv[0][0]=0;
	sprintf(FileName, "%sclothscr.txt",argv[0]);
	
	fputs(FileName, f);
	fclose(f);
	
	
	FILE*fp;
	if(!(fp=fopen(FileName, "r")))
	{
		//t@C̓ǂݍ݂Ɏs
		//ftHg̐ݒ
		g_pNowSeen=(SEEN*)malloc(sizeof(SEEN));
		g_pNowSeen->cloth=IDM_FLAG_VERTICAL|IDM_FLAG_LOCK;
		g_pNowSeen->wind=IDM_WIND_HIGH;
		g_pNowSeen->ball=2;
		g_pNowSeen->poly=GL_FILL;
		g_pNowSeen->next=g_pNowSeen;		
	}
	else
	{
		LoadSetting(fp);
		fclose(fp);
	}
	SetSeen(g_pNowSeen);

	_beginthread(loop, 0, NULL);
	glutMainLoop();
	return(0);
}
