#ifndef MODEL_H
#define MODEL_H

#include "surface.h"
#include "force.h"

/**	_CCʂ\镨
 */
typedef struct model
{
	int NodeCnt;	///f\m[h̐
	NODE	**apNode;
	
	int LinkCnt;	///f\郊N̐
	LINK	**apLink;
	
	int SurfaceCnt;	///f\ʂ̐
	SURFACE	**apSurface;
	
	int ForceCnt;	///󂯂͂̐
	FORCE	**apForce;
	void	**apForceData;
}MODEL;

#define FOR_EACH_MODEL(begin, cnt, func, ...) {\
	for(int each=0; each<cnt; each++)(*func)(begin[each]__VA_ARGS__);}

void ModelCalcNV(MODEL*m);
void ModelDraw(MODEL*m);
void ModelAdjust(MODEL*m);
void ModelFinal(MODEL*m);
void ModelForce(MODEL*m);

#endif
