#ifndef NODE_H
#define NODE_H
/** @file f\_Node̐錾
	@auther Naoki_I
 */

typedef struct Node NODE;

#include "vector3.h"
#include "force.h"

#define FOR_EACH_NODE(begin, cnt, func, ...) {\
	for(int each=0; each<cnt; each++)(*func)(begin[each]__VA_ARGS__);}

/**	̓_

 */
struct Node
{
	VECTOR3 Pos;	///W
	VECTOR3 BPos;	///1t[O̍W
	VECTOR3 LPos;
	VECTOR3 Vel;	///x
	VECTOR3 NormalVector;
	v3unit_t r;	//m[h̑傫(a)
	v3unit_t w;	//m[h̏d
	
	int ForceCnt;	///󂯂͂̐
	FORCE	**apForce;
	void	**apForceData;
};

NODE* NewNode(VECTOR3*Pos, v3unit_t r, v3unit_t w, int ForceCnt);

/** x̍ČvZ
	x=(Pos-BPos)/ds(Œ);
	OK
 */
void NodeCalcVel(NODE*n);

/** w肵ړ
 */
void NodeMove(NODE*n, const VECTOR3*dist);

/** xړ
 */
void NodeAddVel(NODE*n);

void SetNormalVector(NODE*n);
void GetNormalVector(VECTOR3*ret, const NODE*n);

void NodePos2LPos(NODE*n);
void NodePos2BPos(NODE*n);

int NodesAdjust(NODE**apNode);
void NodesCalcNV(NODE**apNode);
void NodesMove(NODE**apNode);
void NodesForce(NODE**apNode);
#endif
