#ifndef SURFACE_H
#define SURFACE_H

#include "link.h"

#define FOR_EACH_SURFACE(begin, cnt, func, ...) {\
	for(int each=0; each<cnt; each++)func(begin[each]__VA_ARGS__);}

typedef struct surface SURFACE;

typedef void SURFACE_FORCE(SURFACE*s);

struct surface
{
	NODE	*apNode[4];
	LINK	*apLink[4];
	VECTOR3	NormalVector;
};

void SurfaceDraw(SURFACE*s);
SURFACE* NewSurface(LINK*l0,LINK*l1,LINK*l2,LINK*l3);
/** @ʂƂɌvZ
 */
void CalcNormalVector(SURFACE*s);

//@m[hɎw肷
void ClearNormalVector(int Cnt, NODE**apNode);
void AddNormalVector(int Cnt, SURFACE**apSurface);
void NormalizeNormalVector(int Cnt, NODE**apNode);


void SurfaceMove(SURFACE*s, const VECTOR3*d);

//Force
typedef struct airreg
{
	int SurfaceCnt;
	SURFACE**apSurface;
}AIRREG;
void AirRegDoNext(void*pData);
void* NewAirRegData(int SurfaceCnt, SURFACE**apSurface);


#endif
