#ifndef VECTOR_H
#define VECTOR_H

/** @file 3xNg\\̂`
	
	3xNg\vector3(typedef VECTOR3)\̂
	𑀍삷ׂ̊֐S`
	
	@auther Naoki_I
 */

#include <math.h>

#define glNormal3v(v) glNormal3fv(v)
#define glVertex3v(v) glVertex3fv(v)
#define glTranslate(x,y,z) glTranslatef(x,y,z)
typedef float v3unit_t;
typedef struct vector3
{
	v3unit_t v[3];
}VECTOR3;

void v3Set(VECTOR3*v, v3unit_t x, v3unit_t y, v3unit_t z);

/** ς߂
 */
double v3GetIP(const VECTOR3*restrict v1, const VECTOR3*restrict v2);
/** Oς߂
 */
void v3GetVP(VECTOR3*restrict ret, const VECTOR3*restrict v1, const VECTOR3*restrict v2);

/** xNg̒߂
 */
v3unit_t v3GetLength(const VECTOR3*v);

/** 2_Ԃ̋߂
 */
v3unit_t v3GetDist(const VECTOR3*restrict to, const VECTOR3*restrict from);

/** 2_Ԃ̍߂
 */
void v3GetVDist(VECTOR3*restrict ret, const VECTOR3*restrict to, const VECTOR3*restrict from);

/** tosrc𑫂
 */
void v3Plus(VECTOR3*restrict ret, const VECTOR3*restrict to, const VECTOR3*restrict src);

/** tosrc
 */
void v3Minus(VECTOR3*restrict ret, const VECTOR3*restrict to, const VECTOR3*restrict src);

/** tosrc𑫂
 */
void v3PlusEq(VECTOR3*restrict to, const VECTOR3*restrict src);

/** tosrc
 */
void v3MinusEq(VECTOR3*restrict to, const VECTOR3*restrict src);

/**
 */ 
void v3Mult(VECTOR3*restrict to, VECTOR3*restrict src, v3unit_t d);
void v3MultEq(VECTOR3* to, v3unit_t d);

/**
 */
void v3Div(VECTOR3*restrict to, VECTOR3*restrict src, v3unit_t d);
void v3DivEq(VECTOR3* to, v3unit_t d);

#endif
