#include <malloc.h>

#include "debug.h"
#include "force.h"

VECTOR3 g_G={{0.0, -0.009, 0.0}};

void ForceGravity(void*pData)
{
	NodeMove(((GDATA*)pData)->pNode, &g_G);
}

void* NewGravityData(NODE*pNode)
{
	GDATA*pNew=(GDATA*)malloc(sizeof(GDATA));
	pNew->pNode=pNode;
	return (void*)pNew;
}
